package com.fr.plugin;

import com.fr.web.struct.AssembleComponent;
import com.fr.web.struct.Atom;
import com.fr.web.struct.Component;
import com.fr.web.struct.browser.RequestClient;
import com.fr.web.struct.category.ScriptPath;
import com.fr.web.struct.category.StylePath;

public class MyIPTokenComponent extends AssembleComponent
{
    public static MyIPTokenComponent KEY = new MyIPTokenComponent();

    private MyIPTokenComponent ()
    {
    }

    @Override
    public Atom[] refer()
    {
        return new Atom[]{
                new Component()
                {
                    @Override
                    public ScriptPath script(RequestClient req)
                    {
                        return ScriptPath.build("com/fr/plugin/web/js/table.js");
                    }
                },
                new Component()
                {
                    @Override
                    public ScriptPath script(RequestClient req)
                    {
                        return ScriptPath.build("com/fr/plugin/web/js/userIPAdd.js");
                    }
                },
                new Component()
                {
                    @Override
                    public ScriptPath script(RequestClient req)
                    {
                        return ScriptPath.build("com/fr/plugin/web/js/TokenIPUpdate.js");
                    }
                },
                new Component()
                {
                    @Override
                    public ScriptPath script(RequestClient req)
                    {
                        return ScriptPath.build("com/fr/plugin/web/js/tokenConfig.js");
                    }
                },

        };
    }

    @Override
    public ScriptPath script(RequestClient req)
    {
        return ScriptPath.build("com/fr/plugin/web/js/ipConfig.js");
    }

    @Override
    public StylePath style(RequestClient req)
    {
        return StylePath.build("com/fr/plugin/web/js/iptoken.css");
    }

}
