package com.fr.plugin.http.API;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.MyDecisionDBAccessProvider;
import com.fr.plugin.dao.MyDao_IPRange;
import com.fr.plugin.dao.MyDao_UserToken;
import com.fr.plugin.entity.MyIPRange;
import com.fr.plugin.entity.MyUserToken;
import com.fr.stable.StringUtils;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

public class API_SEL extends BaseHttpHandler
{
    @Override
    public RequestMethod getMethod()
    {
        return null;
    }

    @Override
    public String getPath()
    {
        return "/API_SEL";
    }

    @Override
    public boolean isPublic()
    {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception
    {
        DBAccessor dbAccessor = MyDecisionDBAccessProvider.getDbAccessor();
        String s = new MyGetBody().getBody(req);
        JSONObject APIJson;
        String userName = StringUtils.BLANK;
        String userToken = StringUtils.BLANK;
        String xxx = StringUtils.BLANK;

        if(StringUtils.isNotBlank(s))
        {
            APIJson = new JSONObject(s);
            userName = APIJson.getString("userName");
            userToken = APIJson.getString("userToken");
            xxx = APIJson.getString("xxx");
        }

        String finalUserName = userName;
        String finalUserToken = userToken;
//        String finalCType = cType;
        List<MyUserToken> entityList1 = null;
        List<MyIPRange> entityList2 = null;
        if (xxx.equals("tokenTable"))
        {
            entityList1 = dbAccessor.runQueryAction(daoContext ->
            {
                QueryCondition queryCondition = QueryFactory.create();
                //满足条件时给出对应数据，不满足时返回全部数据
                if(StringUtils.isNotBlank(finalUserName) || StringUtils.isNotBlank(finalUserToken))
                {
                    queryCondition.addRestriction(RestrictionFactory.or(
                            RestrictionFactory.eq("userName", finalUserName),
                            RestrictionFactory.eq("userToken", finalUserToken)));
                }
                return daoContext.getDAO(MyDao_UserToken.class).find(queryCondition);
            });
        } else {
            entityList2 = dbAccessor.runQueryAction(daoContext ->
            {
                QueryCondition queryCondition = QueryFactory.create();
                //满足条件时给出对应数据，不满足时返回全部数据
                if(StringUtils.isNotBlank(finalUserName) || StringUtils.isNotBlank(finalUserToken))
                {
                    queryCondition.addRestriction(RestrictionFactory.or(
                            RestrictionFactory.eq("userName", finalUserName),
                            RestrictionFactory.eq("userToken", finalUserToken)));
                }
                return daoContext.getDAO(MyDao_IPRange.class).find(queryCondition);
            });
        }

        JSONArray jsonArray;
        if (xxx.equals("tokenTable"))
        {
            jsonArray = JSONArray.create(entityList1);
        }
        else
        {
            jsonArray = JSONArray.create(entityList2);
        }
        WebUtils.printAsJSON(res,jsonArray);
        // WebUtils.printAsString(res, String.valueOf(entityList.size()));
    }
}