package com.fr.plugin.http.API;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.plugin.MyDecisionDBAccessProvider;
import com.fr.plugin.dao.MyDao_IPRange;
import com.fr.plugin.dao.MyDao_UserToken;
import com.fr.plugin.entity.MyIPRange;
import com.fr.plugin.entity.MyUserToken;
import com.fr.stable.StringUtils;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class API_UPD extends BaseHttpHandler
{
    @Override
    public RequestMethod getMethod()
    {
        return null;
    }

    @Override
    public String getPath()
    {
        return "/API_UPD";
    }

    @Override
    public boolean isPublic()
    {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception
    {
        DBAccessor dbAccessor = MyDecisionDBAccessProvider.getDbAccessor();
        String s = new MyGetBody().getBody(req);
        JSONObject APIJson = new JSONObject(s);

        String lx = APIJson.getString("lx");
        String params1 = APIJson.getString("params1");
        String params2 = APIJson.getString("params2");

        if(!StringUtils.isNotBlank(params1) || !StringUtils.isNotBlank(params2))
        {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("msg","update fail, params Cannot be empty!");
            jsonObject.put("code",105);
            WebUtils.printAsJSON(res, jsonObject);
            return;
        }

        MyUserToken myUserToken_0 = new MyUserToken();
        MyIPRange myIPRange_0 = new MyIPRange();

        if(lx.equals("token"))
        {
            myUserToken_0 = dbAccessor.runQueryAction(daoContext -> daoContext.getDAO(MyDao_UserToken.class).
                    findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("userName", params1))));
            myUserToken_0.setUserToken(params2);
        }
        else
        {
            myIPRange_0 = dbAccessor.runQueryAction(daoContext -> daoContext.getDAO(MyDao_IPRange.class).
                    findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("id",params1))));
            myIPRange_0.setIPAddress(params2);

        }

        MyUserToken finalUserToken = myUserToken_0;
        MyIPRange finalIPRange = myIPRange_0;
        try
        {
            dbAccessor.runDMLAction(
                    daoContext ->
                    {
                        if(lx.equals("token"))
                        {
                            daoContext.getDAO(MyDao_UserToken.class).update(finalUserToken);
                        }
                        else
                        {
                            daoContext.getDAO(MyDao_IPRange.class).update(finalIPRange);
                        }
                        return null;
                    });
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("msg", "已更新/添加~~~ \"" + params1 + "\"");
            jsonObject.put("code",200);
            WebUtils.printAsJSON(res, jsonObject);
        }catch (Exception e)
        {
            e.printStackTrace();
            WebUtils.printAsString(res, e.getCause().getMessage().split(";")[0]);
        }
    }
}

