!(function ()
{

    var IpHeader = [[
        { text: "id" },
        { text: "IP" },
        { text: "删除" },
        { text: "修改" }
    ]];

    var TokenHeader = [[
        { text: "id" },
        { text: "用户名" },
        { text: "Token" },
        { text: "删除" },
        { text: "修改" }
    ]];

    var tableType = "token";

    function resolvePath(path, isPublic)
    {
        if (!path || path[0] !== '/')
        {
            path = '/' + path;
        }
        return isPublic === true ? '/plugin/public/com.fr.plugin.test.IPFilter3' + path : '/plugin/private/com.fr.plugin.test.IPFilter3' + path;
    }

    var IPAndTokenTable = BI.inherit(BI.Widget,
        {
            props: {
                    baseCls: "iptoken-table",
                    tableType: "ipTable"
                },
            beforeInit: function (render)
                {
                    var that = this;
                    this.getData(
                        function(data)
                        {
                            that.allData = data;
                            render();
                        }
                    );
                },
            getData: function (callBack)
                {
                    var that = this;
                    var url = "/API_SEL";
                    Dec.reqPost(resolvePath(url, true),
                        {
                            xxx: that.options.tableType
                        },
                        function(data)
                        {
                            var tempData = BI.map(data,
                                function(i, v)
                                {
                                    return BI.map(v,
                                        function(ii, vv)
                                        {
                                            return {
                                                text: vv,
                                                whiteSpace: "normal"
                                            };
                                        });
                                });
                            BI.each(tempData,
                                function(i, v)
                                {
                                    v.push(
                                        {
                                            type: "bi.button",
                                            text: "删除",
                                            handler:
                                                function()
                                                {
                                                    var id = v[0].text;
                                                    var ip = v[1].text;
                                                    var url = "/API_DEL";
                                                    Dec.reqDelete(
                                                        resolvePath(url, true),
                                                        {
                                                            id: id,
                                                            ip: ip
                                                        },
                                                        function()
                                                        {
                                                            that.reload();
                                                        })
                                                }
                                        }),
                                    v.push(
                                        {
                                            type: "bi.button",
                                            text: "修改",
                                            handler: function ()
                                            {
                                                var id = "updatePane";
                                                var p1 = v[1].text;
                                                var p2 = v[2].text;
                                                var head = "修改Token"
                                                if(tableType === "ip")
                                                {
                                                    p1 = v[0].text;
                                                    p2 = v[1].text;
                                                    head = "修改IP"
                                                }
                                                BI.Popovers.create(id,
                                                    {
                                                        type: "bi.bar_popover",
                                                        header: head,
                                                        size: "small",
                                                        body:
                                                            {
                                                                type: "bi.upd.userTokenOrIp",
                                                                cType: tableType,
                                                                p1: p1,
                                                                p2: p2,
                                                                ref: function (e)
                                                                {
                                                                    that.updatePane = e;
                                                                }
                                                            },
                                                        listeners: [
                                                            {
                                                                eventName: "EVENT_CANCEL",
                                                                action: function ()
                                                                {
                                                                    BI.Msg.toast("取消修改~");
                                                                }
                                                            },
                                                            {
                                                                eventName: "EVENT_CONFIRM",
                                                                action: function ()
                                                                {
                                                                    var params2 = that.updatePane.getValue();
                                                                    console.info(params2);
                                                                    Dec.reqPost(resolvePath("/API_UPD", true),
                                                                        {
                                                                            params1: params2.params1,
                                                                            params2: params2.params2,
                                                                            lx: tableType
                                                                        }, function ()
                                                                        {
                                                                            BI.Msg.toast("修改成功~");
                                                                            that.reload();
                                                                        });
                                                                }
                                                            }]
                                                    }).open(id);
                                            }
                                        })
                                });
                            callBack(tempData);
                        }
                    );
                },
            reload: function()
                {
                    var that = this;
                    this.getData(
                        function(data)
                        {
                            that.tableIns.populate(data);
                        }
                    )
                },
            render: function()
                {
                    var that = this;
                    var header = TokenHeader;
                    var minCS = [100, 100, 100];
                    var CS = [100, 100, 100];

                    if(this.options.tableType === "ipTable")
                    {
                        header = IpHeader;
                        minCS = [100, 100];
                        CS = [100, 100];
                        tableType = "ip";
                    }
                    return {
                        type: "bi.table_view",
                        width: 600,
                        height: 400,
                        ref: function(e)
                            {
                                that.tableIns = e;
                            },
                        minColumnSize: minCS,
                        columnSize: CS,
                        regionColumnSize: [300, "fill"],
                        items: this.allData,
                        header: header
                    }
                }
        });
    BI.shortcut("dec.management.iptoken.table", IPAndTokenTable);
}());